###############################################################################
#                                Main package                                 #
###############################################################################

Summary: Cross-compiler/Cross-assembler for 6502 systems
Name: cc65
Version: 2.13.3
Release: 1%{?dist}
License: zlib and distributable
Group: Development/Languages
Source0: ftp://ftp.musoftware.de/pub/uz/%{name}/%{name}-sources-%{version}.tar.bz2
Patch0: %{name}-2.13.2-make.patch
Patch1: %{name}-2.13.2-man.patch
URL: http://www.cc65.org/
BuildRequires: sgml-tools
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%description
A C cross-compiler for 6502 systems, including a macro-assembler that
supports 6502, 65SC02 and 65816 CPUs, a linker, an archiver and some
other tools. To create programs for one of the supported target
machines, you have to install at least one of the library packages.

%files
%defattr(-,root,root,-)
%doc announce.txt
%doc doc/BUGS
%doc doc/CREDITS
%doc doc/readme.1st
%{_bindir}/ar65
%{_bindir}/ca65
%{_bindir}/ca65html
%{_bindir}/cc65
%{_bindir}/cl65
%{_bindir}/co65
%{_bindir}/da65
%{_bindir}/ld65
%{_bindir}/od65
%dir %{_datadir}/%{name}
%dir %{_datadir}/%{name}/emd
%dir %{_datadir}/%{name}/joy
%dir %{_datadir}/%{name}/lib
%dir %{_datadir}/%{name}/tgi
%dir %{_datadir}/%{name}/include
%{_datadir}/%{name}/include/*.h
%{_datadir}/%{name}/include/em
%{_datadir}/%{name}/include/joystick
%{_datadir}/%{name}/include/mouse
%{_datadir}/%{name}/include/sys
%{_datadir}/%{name}/include/tgi
%{_datadir}/%{name}/asminc
%{_mandir}/man1/ar65.1*
%{_mandir}/man1/ca65.1*
%{_mandir}/man1/ca65html.1*
%{_mandir}/man1/cc65.1*
%{_mandir}/man1/cl65.1*
%{_mandir}/man1/co65.1*
%{_mandir}/man1/da65.1*
%{_mandir}/man1/ld65.1*
%{_mandir}/man1/od65.1*



###############################################################################
#                          Documentation subpackage                           #
###############################################################################

%package doc
Requires: %{name} = %{version}-%{release}
Summary: Documentation for the cc65 C compiler
Group: Development/Languages

%description doc
This package contains the documentation for the cc65 C compiler, mostly
in HTML format. Other formats can be generated from the sources.

%files doc
%defattr(-,root,root,-)
%doc doc/*.html
%doc doc/compile.txt
%doc doc/internal.txt
%doc doc/newvers.txt
%doc samples
%doc src/ld65/cfg/*.cfg



###############################################################################
#                             Apple ][ subpackage                             #
###############################################################################

%package apple2
Requires: %{name} = %{version}-%{release}
Summary: Apple ][ specific libraries and headers for the cc65 compiler
Group: Development/Languages

%description apple2
This package contains the header files and libraries needed to write
programs for the Apple ][ using the cc65 cross-compiler.

%files apple2
%defattr(-,root,root,-)
%{_datadir}/%{name}/lib/apple2.lib
%{_datadir}/%{name}/obj/apple2-*.o
%{_datadir}/%{name}/emd/a2.*.emd
%{_datadir}/%{name}/joy/a2.*.joy
%{_datadir}/%{name}/mou/a2.*.mou
%{_datadir}/%{name}/ser/a2.*.ser
%{_datadir}/%{name}/tgi/a2.*.tgi
%{_datadir}/%{name}/cfg/apple2-*.cfg



###############################################################################
#                            Apple //e subpackage                             #
###############################################################################

%package apple2enh
Requires: %{name} = %{version}-%{release}
Summary: Apple //e specific libraries and headers for the cc65 compiler
Group: Development/Languages

%description apple2enh
This package contains the header files and libraries needed to write
programs for the Apple //e using the cc65 cross-compiler.

%files apple2enh
%defattr(-,root,root,-)
%{_datadir}/%{name}/lib/apple2enh.lib
%{_datadir}/%{name}/obj/apple2enh-*.o
%{_datadir}/%{name}/emd/a2e.*.emd
%{_datadir}/%{name}/joy/a2e.*.joy
%{_datadir}/%{name}/mou/a2e.*.mou
%{_datadir}/%{name}/ser/a2e.*.ser
%{_datadir}/%{name}/tgi/a2e.*.tgi
%{_datadir}/%{name}/cfg/apple2enh-*.cfg



###############################################################################
#                              Atari subpackage                               #
###############################################################################

%package atari
Requires: %{name} = %{version}-%{release}
Summary: Atari specific libraries and headers for the cc65 compiler
Group: Development/Languages

%description atari
This package contains the header files and libraries needed to write
programs for the 8 bit Atari machines using the cc65 cross-compiler.

%files atari
%defattr(-,root,root,-)
%{_datadir}/%{name}/lib/atari.lib
%{_datadir}/%{name}/joy/atari*.joy



###############################################################################
#                            Oric Atmos subpackage                            #
###############################################################################

%package atmos
Requires: %{name} = %{version}-%{release}
Summary: Oric Atmos specific libraries and headers for the cc65 compiler
Group: Development/Languages

%description atmos
This package contains the header files and libraries needed to write
programs for the Oric Atmos using the cc65 cross-compiler.

%files atmos
%defattr(-,root,root,-)
%{_datadir}/%{name}/lib/atmos.lib
%{_datadir}/%{name}/tgi/atmos-*.tgi



###############################################################################
#                               C128 subpackage                               #
###############################################################################

%package c128
Requires: %{name} = %{version}-%{release}
Summary: C128 specific libraries and headers for the cc65 compiler
Group: Development/Languages

%description c128
This package contains the header files and libraries needed to write
programs for the Commodore C128 using the cc65 cross-compiler.

%files c128
%defattr(-,root,root,-)
%{_datadir}/%{name}/lib/c128.lib
%{_datadir}/%{name}/emd/c128-*.emd
%{_datadir}/%{name}/joy/c128-*.joy
%{_datadir}/%{name}/mou/c128-*.mou
%{_datadir}/%{name}/ser/c128-*.ser
%{_datadir}/%{name}/tgi/c128-*.tgi



###############################################################################
#                                C16 subpackage                               #
###############################################################################

%package c16
Requires: %{name} = %{version}-%{release}
Summary: C16/116 specific libraries and headers for the cc65 compiler
Group: Development/Languages

%description c16
This package contains the header files and libraries needed to write
programs for the Commodore C16/116 using the cc65 cross-compiler.

%files c16
%defattr(-,root,root,-)
%{_datadir}/%{name}/lib/c16.lib
%{_datadir}/%{name}/emd/c16-*.emd
%{_datadir}/%{name}/joy/c16-*.joy



###############################################################################
#                               C64 subpackage                                #
###############################################################################

%package c64
Requires: %{name} = %{version}-%{release}
Summary: C64 specific libraries and headers for the cc65 compiler
Group: Development/Languages

%description c64
This package contains the header files and libraries needed to write
programs for the Commodore C64 using the cc65 cross-compiler.

%files c64
%defattr(-,root,root,-)
%{_datadir}/%{name}/lib/c64.lib
%{_datadir}/%{name}/emd/dtv-*.emd
%{_datadir}/%{name}/emd/c64-*.emd
%{_datadir}/%{name}/joy/c64-*.joy
%{_datadir}/%{name}/mou/c64-*.mou
%{_datadir}/%{name}/ser/c64-*.ser
%{_datadir}/%{name}/tgi/c64-*.tgi



###############################################################################
#                              CBM510 subpackage                              #
###############################################################################

%package cbm510
Requires: %{name} = %{version}-%{release}
Summary: CBM 510 specific libraries and headers for the cc65 compiler
Group: Development/Languages

%description cbm510
This package contains the header files and libraries needed to write
programs for the Commodore CBM 510 (aka P500) using the cc65
cross-compiler.

%files cbm510
%defattr(-,root,root,-)
%{_datadir}/%{name}/lib/cbm510.lib
%{_datadir}/%{name}/emd/cbm510-*.emd
%{_datadir}/%{name}/joy/cbm510-*.joy
%{_datadir}/%{name}/ser/cbm510-*.ser



###############################################################################
#                              CBM610 subpackage                              #
###############################################################################

%package cbm610
Requires: %{name} = %{version}-%{release}
Summary: CBM 610 specific libraries and headers for the cc65 compiler
Group: Development/Languages

%description cbm610
This package contains the header files and libraries needed to write
programs for the Commodore PET-II (CBM600/700) family of computers using
the cc65 cross-compiler.

%files cbm610
%defattr(-,root,root,-)
%{_datadir}/%{name}/lib/cbm610.lib
%{_datadir}/%{name}/emd/cbm610-*.emd
%{_datadir}/%{name}/ser/cbm610-*.ser



###############################################################################
#                               GEOS subpackage                               #
###############################################################################

%package geos
Requires: %{name} = %{version}-%{release}
Summary: GEOS specific libraries and headers for the cc65 compiler
Group: Development/Languages

%description geos
This package contains the header files and libraries needed to write
GEOS programs for the C64/C128 using the cc65 cross-compiler.

%files geos
%defattr(-,root,root,-)
%{_bindir}/grc
%{_datadir}/%{name}/lib/geos.lib
%{_datadir}/%{name}/include/geos
%{_datadir}/%{name}/emd/geos-*.emd
%{_datadir}/%{name}/joy/geos-*.joy
%{_datadir}/%{name}/tgi/geos-*.tgi
%{_mandir}/man1/grc.1*



###############################################################################
#                               Lynx subpackage                               #
###############################################################################

%package lynx
Requires: %{name} = %{version}-%{release}
Summary: Lynx specific libraries and headers for the cc65 compiler
Group: Development/Languages

%description lynx
This package contains the header files and libraries needed to write
programs for the Lynx Game Console using the cc65 cross-compiler.

%files lynx
%defattr(-,root,root,-)
%{_datadir}/%{name}/lib/lynx.lib
%{_datadir}/%{name}/joy/lynx-*.joy
%{_datadir}/%{name}/ser/lynx-*.ser
%{_datadir}/%{name}/tgi/lynx-*.tgi



###############################################################################
#                               NES subpackage                                #
###############################################################################

%package nes
Requires: %{name} = %{version}-%{release}
Summary: NES specific libraries and headers for the cc65 compiler
Group: Development/Languages

%description nes
This package contains the header files and libraries needed to write
programs for the Nintendo Entertainment System using the cc65
cross-compiler.

%files nes
%defattr(-,root,root,-)
%{_datadir}/%{name}/lib/nes.lib
%{_datadir}/%{name}/joy/nes-*.joy



###############################################################################
#                               PET subpackage                                #
###############################################################################

%package pet
Requires: %{name} = %{version}-%{release}
Summary: PET specific libraries and headers for the cc65 compiler
Group: Development/Languages

%description pet
This package contains the header files and libraries needed to write
programs for the Commodore PET family of computers using the cc65
cross-compiler.

%files pet
%defattr(-,root,root,-)
%{_datadir}/%{name}/lib/pet.lib
%{_datadir}/%{name}/joy/pet-*.joy



###############################################################################
#                              Plus/4 subpackage                              #
###############################################################################

%package plus4
Requires: %{name} = %{version}-%{release}
Summary: Plus/4 specific libraries and headers for the cc65 compiler
Group: Development/Languages

%description plus4
This package contains the header files and libraries needed to write
programs for the Commodore Plus/4 and C16/116 using the cc65
cross-compiler.

%files plus4
%defattr(-,root,root,-)
%{_datadir}/%{name}/lib/plus4.lib
%{_datadir}/%{name}/joy/plus4-*.joy
%{_datadir}/%{name}/ser/plus4-*.ser



###############################################################################
#                           Supervision subpackage                            #
###############################################################################

%package supervision
Requires: %{name} = %{version}-%{release}
Summary: Supervision specific libraries and headers for the cc65 compiler
Group: Development/Languages

%description supervision
This package contains the header files and libraries needed to write
programs for the Supervision Game console using the cc65 cross-compiler.

%files supervision
%defattr(-,root,root,-)
%{_datadir}/%{name}/lib/supervision.lib
%{_datadir}/%{name}/cfg/supervision-*.cfg



###############################################################################
#                              VIC20 subpackage                               #
###############################################################################

%package vic20
Requires: %{name} = %{version}-%{release}
Summary: VIC20 specific libraries and headers for the cc65 compiler
Group: Development/Languages

%description vic20
This package contains the header files and libraries needed to write
programs for the Commodore VIC20 using the cc65 cross-compiler.

%files vic20
%defattr(-,root,root,-)
%{_datadir}/%{name}/lib/vic20.lib
%{_datadir}/%{name}/joy/vic20-*.joy
%{_datadir}/%{name}/cfg/vic20-*.cfg



###############################################################################
#                                    Build                                    #
###############################################################################



%prep
%setup -q
%patch0 -p1 -b .make
%patch1 -p1 -b .man

# fix EOLs
sed -i -e 's/\r//g' announce.txt

# fix encoding
f=doc/CREDITS
iconv -f ISO8859-1 -t UTF-8 -o $f.new $f
touch -r $f $f.new
mv $f.new $f


%build
# Binaries
make -C src -f make/gcc.mak CFLAGS="$RPM_OPT_FLAGS -std=c89"
# Libraries
make -C libsrc -s zap all
# Documentation
make -C doc html


%install
rm -rf $RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT%{_bindir}
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}/{asminc,cfg,emd,include/{em,geos,joystick,mouse,sys,tgi},joy,lib,mou,obj,ser,tgi}

# Binaries
install -p -m 755 src/ar65/ar65 $RPM_BUILD_ROOT%{_bindir}
install -p -m 755 src/ca65/ca65 $RPM_BUILD_ROOT%{_bindir}
install -p -m 755 src/ca65html/ca65html $RPM_BUILD_ROOT%{_bindir}
install -p -m 755 src/cc65/cc65 $RPM_BUILD_ROOT%{_bindir}
install -p -m 755 src/cl65/cl65 $RPM_BUILD_ROOT%{_bindir}
install -p -m 755 src/co65/co65 $RPM_BUILD_ROOT%{_bindir}
install -p -m 755 src/da65/da65 $RPM_BUILD_ROOT%{_bindir}
install -p -m 755 src/grc/grc $RPM_BUILD_ROOT%{_bindir}
install -p -m 755 src/ld65/ld65 $RPM_BUILD_ROOT%{_bindir}
install -p -m 755 src/od65/od65 $RPM_BUILD_ROOT%{_bindir}

# Libraries and includes
install -p -m 644 libsrc/*.lib $RPM_BUILD_ROOT%{_datadir}/%{name}/lib
install -p -m 644 include/*.h $RPM_BUILD_ROOT%{_datadir}/%{name}/include
install -p -m 644 include/geos/*.h $RPM_BUILD_ROOT%{_datadir}/%{name}/include/geos
install -p -m 644 include/em/*.h $RPM_BUILD_ROOT%{_datadir}/%{name}/include/em
install -p -m 644 include/joystick/*.h $RPM_BUILD_ROOT%{_datadir}/%{name}/include/joystick
install -p -m 644 include/mouse/*.h $RPM_BUILD_ROOT%{_datadir}/%{name}/include/mouse
install -p -m 644 include/sys/*.h $RPM_BUILD_ROOT%{_datadir}/%{name}/include/sys
install -p -m 644 include/tgi/*.h $RPM_BUILD_ROOT%{_datadir}/%{name}/include/tgi
install -p -m 644 asminc/*.inc $RPM_BUILD_ROOT%{_datadir}/%{name}/asminc

# Extra object files
for extra in libsrc/*-*.o; do
    install -p -m 644 ${extra} $RPM_BUILD_ROOT%{_datadir}/%{name}/obj
done

# Additional linker configurations
for config in src/ld65/cfg/*-*.cfg; do
    install -p -m 644 ${config} $RPM_BUILD_ROOT%{_datadir}/%{name}/cfg
done

# Drivers
install -p -m 644 libsrc/*.emd $RPM_BUILD_ROOT%{_datadir}/%{name}/emd
install -p -m 644 libsrc/*.joy $RPM_BUILD_ROOT%{_datadir}/%{name}/joy
install -p -m 644 libsrc/*.mou $RPM_BUILD_ROOT%{_datadir}/%{name}/mou
install -p -m 644 libsrc/*.ser $RPM_BUILD_ROOT%{_datadir}/%{name}/ser
install -p -m 644 libsrc/*.tgi $RPM_BUILD_ROOT%{_datadir}/%{name}/tgi

# Man pages
mkdir -p $RPM_BUILD_ROOT%{_mandir}/man1
install -p -m 644 packages/debian/*.1 $RPM_BUILD_ROOT%{_mandir}/man1


%clean
rm -rf $RPM_BUILD_ROOT


%changelog
* Sat Mar 31 2012 Dan Horák <dan[at]danny.cz> - 2.13.3-1
- updated to 2.13.3

* Sat Mar 31 2012 Dan Horák <dan[at]danny.cz> - 2.13.2-2
- fix include paths for ca65 and cc65

* Fri Oct 15 2010 Dan Horák <dan[at]danny.cz> - 2.13.2-1
- updated to 2.13.2
- include man pages

* Sat Mar 21 2009 Dan Horák <dan[at]danny.cz> - 2.12.0-1
- initial Fedora package based on upstream
